package podstawy_plikow;

import java.io.File;
import java.io.FileNotFoundException;
import java.util.Map;
import java.util.Scanner;
import java.util.TreeMap;
import java.util.logging.Level;
import java.util.logging.Logger;

public class PoliczWszystkieSlowa {
    public static void main(String[] args) {
        Map<String, Integer> slownik = new TreeMap<>();
        try(Scanner scanner = new Scanner(new File("pan-tadeusz.txt"), "UTF-8")) {
            // w tym programie w pętli będziemy czytać kolejne słowa (a nie całe linie)
            // Zmieniamy ustawienia Scannera, aby ze słów usunąć znaki interpunkcyjne za pomoą "wyrażenia regularnego" / "regexp"
            // delimiterem jest ciąg takich znaków, które nie są ani literą, ani cyfrą
            scanner.useDelimiter("[^\\p{L}\\d]+");
            while(scanner.hasNext()) {
                String slowo = scanner.next().toLowerCase();
                // System.out.println(slowo);
                int ile = slownik.getOrDefault(slowo, 0);
                slownik.put(slowo, ile+1);
            }
        } catch (FileNotFoundException ex) {
            Logger.getLogger(PoliczWszystkieSlowa.class.getName()).log(Level.SEVERE, null, ex);
        }
        // slownik.forEach((slowo, ile) -> System.out.println(slowo + " : " + ile));

        slownik.entrySet().stream()
                .sorted(Map.Entry.comparingByValue())
                .forEachOrdered(entry -> System.out.println(entry.getKey() + " : " + entry.getValue()));
    }
}
