package gra;

import java.awt.Color;
import java.awt.Graphics;
import java.util.concurrent.ThreadLocalRandom;
import javax.swing.JOptionPane;
import javax.swing.JPanel;

// Aby narysować coś w obszarze okna, musimy:
// - utworzyć własną wersję ("podklasę") klasy JPanel
// - w niej nadpisać metodę paintComponent i w tej metodzie za pomocą obiektu "g"
//   narysować wszystko, co ma być widoczne.

public class Plansza extends JPanel {
    static final int ROZMIAR_POLA = 50;
    static final int SREDNICA = 40;

    int gracz_x = 1;
    int gracz_y = 1;
    int skarb_x = 1;
    int skarb_y = 1;

    void wylosujPozycjeSkarbu() {
        var random = ThreadLocalRandom.current();
        skarb_x = random.nextInt(getWidth() / ROZMIAR_POLA);
        skarb_y = random.nextInt(getHeight()/ ROZMIAR_POLA);
    }

    void sprawdz() {
        // metoda wykonywana po każdym ruchu, aby sprawdzić jaka jest sytuacja
        if(gracz_x == skarb_x && gracz_y == skarb_y) {
            JOptionPane.showMessageDialog(this, "Brawo, skarb został odnaleziony!");
        }
    }

    void lewo() {
        gracz_x -= 1;
        repaint();
    }

    void prawo() {
        gracz_x += 1;
        repaint();
    }

    void gora() {
        gracz_y -= 1;
        repaint();
    }

    void dol() {
        gracz_y += 1;
        repaint();
    }

    @Override
    protected void paintComponent(Graphics g) {
        super.paintComponent(g);

        g.setColor(Color.BLUE);
        g.drawRect(skarb_x * ROZMIAR_POLA, skarb_y * ROZMIAR_POLA, SREDNICA, SREDNICA);

        g.setColor(Color.RED);
        g.fillOval(gracz_x * ROZMIAR_POLA, gracz_y * ROZMIAR_POLA, SREDNICA, SREDNICA);

    }
}
