package gra;

import java.awt.Color;
import java.awt.Graphics;
import java.util.HashSet;
import java.util.Random;
import java.util.Set;
import javax.swing.JPanel;

public class Plansza extends JPanel {
    private Set<Jablko> jablka = new HashSet<>();
    private Random random = new Random();

    // o ile pikseli jablka spadaja w jednym ruchu
    private int skok = 20;

    private double prawdopodobienstwoNowegoJablka = 0.5;

    private int koszyk;
    private int ileZlapanych, ileZgubionych;
    final int SZEROKOSC_KOSZYKA = 50;
    final int WYSOKOSC_KOSZYKA = 20;

    @Override
    protected void paintComponent(Graphics g) {
        super.paintComponent(g);
        for(Jablko jablko : jablka) {
            jablko.narysujSie(g);
        }
        g.setColor(Color.GREEN);
        g.fillRect(koszyk, getHeight()-WYSOKOSC_KOSZYKA, SZEROKOSC_KOSZYKA, WYSOKOSC_KOSZYKA);
    }

    // tresc tej metody bedzie wykonywana cyklicznie co okreslony czas przez timera
    void jedenKrok() {
        Set<Jablko> jablkaDoUsuniecia = new HashSet<>();
        for(Jablko jablko : jablka) {
            jablko.opusc(skok);
            if(jablko.getY() > this.getHeight()-WYSOKOSC_KOSZYKA) {
                if(koszyk <= jablko.getX() && jablko.getX() < koszyk+SZEROKOSC_KOSZYKA) {
                    ileZlapanych++;
                } else {
                    ileZgubionych++;
                }
                jablkaDoUsuniecia.add(jablko);
            }
        }
        jablka.removeAll(jablkaDoUsuniecia);

        if(random.nextDouble() < prawdopodobienstwoNowegoJablka) {
            int x = random.nextInt(this.getWidth() - Jablko.SREDNICA);
            int y = 0;
            Jablko noweJablko = new Jablko(x, y);
            jablka.add(noweJablko);
        }
        this.repaint();
    }

    public int getSkok() {
        return skok;
    }

    public void setSkok(int skok) {
        this.skok = skok;
    }

    public double getPrawdopodobienstwoNowegoJablka() {
        return prawdopodobienstwoNowegoJablka;
    }

    public void setPrawdopodobienstwoNowegoJablka(double prawdopodobienstwoNowegoJablka) {
        this.prawdopodobienstwoNowegoJablka = prawdopodobienstwoNowegoJablka;
    }

    public void ustawKoszyk(int pozycjaMyszy) {
        int nowaPozycja = pozycjaMyszy - SZEROKOSC_KOSZYKA/2;
        if(nowaPozycja < 0) {
            nowaPozycja = 0;
        }
        if(nowaPozycja > getWidth() - SZEROKOSC_KOSZYKA) {
            nowaPozycja = getWidth() - SZEROKOSC_KOSZYKA;
        }
        koszyk = nowaPozycja;
    }

    public int getIleZlapanych() {
        return ileZlapanych;
    }

    public int getIleZgubionych() {
        return ileZgubionych;
    }

}
